# 程式設計須知

這裡收集各種通過 Hyperf 程式設計前應該知曉的知識點或內容點。

## 不能通過全域性變數獲取屬性引數

在 `PHP-FPM` 下可以通過全域性變數獲取到請求的引數，伺服器的引數等，在 `Hyperf` 和 `Swoole` 內，都 **無法** 通過 `$_GET/$_POST/$_REQUEST/$_SESSION/$_COOKIE/$_SERVER`等`$_`開頭的變數獲取到任何屬性引數。

## 通過容器獲取的類都是單例

通過依賴注入容器獲取的都是程序內持久化的，是多個協程共享的，所以不能包含任何的請求唯一的資料或協程唯一的資料，這型別的資料都通過協程上下文去處理，具體請仔細閱讀 [依賴注入](./zh/di.md) 和 [協程](./zh/coroutine.md) 章節。